SystemOrganization addCategory: #ConfigurationOfMentor!

Object subclass: #ConfigurationOfMentor
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMentor'!

!ConfigurationOfMentor class methodsFor: 'development support' stamp: 'AndyKellens 7/31/2012 15:12'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMentor class methodsFor: 'private' stamp: 'AndyKellens 7/31/2012 15:12'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMentor class methodsFor: 'private' stamp: 'AndyKellens 7/31/2012 15:12'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMentor class methodsFor: 'private' stamp: 'AndyKellens 7/31/2012 15:12'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMentor class methodsFor: 'metacello tool support' stamp: 'AndyKellens 7/31/2012 15:12'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMentor class methodsFor: 'loading' stamp: 'AndyKellens 7/31/2012 15:12'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMentor class methodsFor: 'loading' stamp: 'AndyKellens 7/31/2012 15:12'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMentor class methodsFor: 'loading' stamp: 'AndyKellens 7/31/2012 15:12'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMentor class methodsFor: 'accessing' stamp: 'AndyKellens 7/31/2012 15:12'!
project

	^self new project! !

!ConfigurationOfMentor class methodsFor: 'development support' stamp: 'AndyKellens 7/31/2012 15:12'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMentor methodsFor: 'baselines' stamp: 'AndyKellens 7/31/2012 15:16'!
baseline100: spec 
        <version: '1.0-baseline'>
        
        spec for: #common do: [
                spec blessing: #baseline.
                spec repository: 'http://ss3.gemstone.com/ss/Mentor'.    
	
			spec 
				project: 'Mendel'
				with: [
					spec 
						className: 'ConfigurationOfMendel';
						file: 'ConfigurationOfMendel';
						version: '1.0-baseline';
						repository: 'http://ss3.gemstone.com/ss/Mendel/'].

                spec 
                        package: 'FormalConceptAnalysis-FCA';
                        package: 'FormalConceptAnalysis-RCA' with: [ spec requires: 'FormalConceptAnalysis-FCA' ];
				package: 'FormalConceptAnalysis-Tests' with: [ spec requires: 'FormalConceptAnalysis-FCA' ];
				package:'Mentor-Core' with:[spec requires: {'FormalConceptAnalysis-FCA' . 'Mendel'}].
	
                spec
                        group: 'default' with: #('Core' 'Tests');
                        group: 'Core' with: #('FormalConceptAnalysis-FCA' 'FormalConceptAnalysis-RCA');
                        group: 'Tests' with: #('FormalConceptAnalysis-Tests')].! !

!ConfigurationOfMentor methodsFor: 'versions' stamp: 'AndyKellens 7/31/2012 15:16'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0-baseline'.! !

!ConfigurationOfMentor methodsFor: 'accessing' stamp: 'AndyKellens 7/31/2012 15:12'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !
